;******************************************************************************
;    Filename:        pulzgen.asm                                             *
;******************************************************************************
;    1. feladat megoldsa                                                     *
;******************************************************************************
	list	p=12f508     ; list directive to define processor
	list	r=dec
	#include <p12f508.inc> ; processor specific variable definitions

; Konfigurci 
    __CONFIG _XT_OSC & _WDT_OFF & _CP_OFF & _MCLRE_OFF  
 
; Vltozk: az egyetlen vltoz a GPIO port, de az a p12f508.inc fjlban mr
; definilva van
    
; Lbdefincik: a kt kisebb jel utni szm a bit sorszma. Ezeket lehetne
; hasznlni a lbak rugalmas konfigurlshoz, ha a hurokban a szmokat az
; albbi (sszeg) kifejezsekkel helyettestennk (amelyik szm nem
; szerepel a jelsorozatban, azt termszetesen nem hasznljuk).

symm	equ	1<<0	; (gp0), binris rtke 1, szimmetrikus ngyszg
selp	equ	1<<1	; (gp1), binris rtke 2, pozitv szakasz kapu
seln	equ	1<<2	; (gp2), binris rtke 4, negatv szakasz kapu

; A szmokat helyettest kifejezsek:
; 0=0, nincs
; 1=symm (1), nincs
; 2=selp (2)
; 3=symm+selp (1+2), nincs
; 4=seln (4), nincs
; 5=symm+seln (1+4)
; 6=selp+seln (2+4)
; 7=symm+selp+seln (1+2+4)
; A csere utn a lbdefincik jobb oldaln a bitsorszmok szabadon cserlhetk,
; feltve, hogy azok valban kimenetek.
		
;------------------------------------------------------------------------------
; RESET VECTOR
;------------------------------------------------------------------------------
    ORG     0x0000              ; processor reset vector
 ;	GOTO	START		; itt nincs rtelme az ugrsnak
;------------------------------------------------------------------------------
; Fprogram, ebben a formjban 3,2 MHz-re
;------------------------------------------------------------------------------

START
	MOVLW	0xDF		; megengedi, hogy gp2 kimenet legyen
	OPTION
	MOVLW	0X3A		; gpio-nak sznt kezdrtk
	MOVWF	GPIO		; (0*symm+1*selp+0*seln)
	MOVLW	0X38		; gp0,gp1,gp2 legyen kimenet
	TRIS	GPIO		; s ln
MAIN				; ide jn vissza a teljes ciklus
	MOVLW	6		; 0*symm+1*selp+1*seln, tlt
	MOVWF	GPIO		; llt (negatv kapu felfut lt)
	MOVLW	7		; 1*symm+1*selp+1*seln, tlt
	MOVWF	GPIO		; llt (szimm. ngyszg felfut lt)
	MOVLW	5		; 1*symm+0*selp+1*seln, tlt
	MOVWF	GPIO		; llt (stb)
	NOP			; ebben a nyolcadban nincs llts
	NOP
	MOVLW	7		; 1*symm+1*selp+1*seln (hrom magas)
	MOVWF	GPIO
	MOVLW	6		; 0*symm+1*selp+1*seln	
	MOVWF	GPIO
	MOVLW	2		; 0*symm+1*selp+0*seln
	MOVWF	GPIO
	GOTO	MAIN		; zrja a hurkot, nem llt
    END